SCREEN 9
'Keeps track of number of all words that were played
Dim UsedWordsCount As Byte=0
LoadSmallFont("81.FNT")
NewGame:
CLSC(15)
Color(1)
Dim Sprite1 As Byte=0

'Display upper part of Gallows
SetSpriteXY(Sprite1,$4C,0)
DisplaySprite(Sprite1, 2, 2)

'Display lower part of Gallows
SetSpriteXY(Sprite1,$4C,100)
DisplaySprite(Sprite1, 1, 2)
Gosub DisplayCowboy

'Make sure text is not permanent when printed
ERASETEXTFLAGON

Dim LettersUsed As String(26)=""
Dim CharStr As String(5)
'Keeps track of which sprite to move to noose area
Dim HangPtr As Byte=0
Gosub GetNewWord
Main:
Color(1)
GInput At 5,200,"Enter a letter",CharStr;
CharByte=ASC(CharStr)

If CharByte>='a' And CharByte<='z' Then
  CharByte=CharByte And $DF
  CharStr=CHR(CharByte)
  Gosub CheckForLetterInWord
End If
If NewWordMaskStr=NewWordStr Then
  Gosub EffaceSprite
  UsedWordsCount=UsedWordsCount+1
  ERASETEXTFLAGOFF
  GPrint At 5,90,"You saved me!"
  GPrint At 5,110,"Thank-you!"
  Gosub DisplayCowboy
  Dim Toggle As Byte=0
  Dim Lop As Byte
  For Lop=1 To 6
    Gosub EffaceSprite
    Toggle=Toggle Xor 1
    If Toggle=1 Then
      MoveSpriteUp(Sprite1,25,$48)
      MoveSpriteUp(Sprite2,25,$28)
      MoveSpriteUp(Sprite3,25,$4B)
      MoveSpriteUp(Sprite4,25,$50)
      MoveSpriteUp(Sprite5,25,$64)
      MoveSpriteUp(Sprite6,25,$63)
      MoveSpriteUp(Sprite7,25,$6E)
      MoveSpriteUp(Sprite8,25,$6D)
      MoveSpriteUp(Sprite9,25,$83)
      MoveSpriteUp(Sprite10,25,$82)
    Else
      MoveSpriteDown(Sprite1,25,$4C)
      MoveSpriteDown(Sprite2,25,$2C)
      MoveSpriteDown(Sprite3,25,$50)
      MoveSpriteDown(Sprite4,25,$55)
      MoveSpriteDown(Sprite5,25,$69)
      MoveSpriteDown(Sprite6,25,$68)
      MoveSpriteDown(Sprite7,25,$73)
      MoveSpriteDown(Sprite8,25,$72)
      MoveSpriteDown(Sprite9,25,$88)
      MoveSpriteDown(Sprite10,25,$87)
    End If
    Gosub MontreSprite
    If Toggle=1 Then
      PlayVOC(14)
      Delay(10)
    Else
      Delay(100)
    End If
  Next
  If UsedWordsCount<50 Then
    Goto AskToPlayAgain
  Else
    Goto CompletedAllWords
  End If
End If
Color(2)
GPrint At 1,248, LettersUsed
Goto Main

CompletedAllWords:
GPrint At 5,220,"Congratulations!"
GPrint At 5,230,"Completed all 50 words!"
GPrint At 5,240,"Press any key to exit"
Dim KeyVal As Byte
KeyVal=Inkey
END

AskToPlayAgain:
GInput At 5,230,"Play again(y/n)",CharStr
If CharStr="y" Then
  Goto NewGame
End If
END

Sub DisplayCowboy
'Display body
LoadSprite(Sprite1,$AF, $4C, 3)
ShowSprite(Sprite1, NO_WVRT)

'Display head
Dim Sprite2 As Byte=1
LoadSprite(Sprite2,$A3, $2C, 4)
ShowSprite(Sprite2, NO_WVRT)

'Display right arm
Dim Sprite3 As Byte=3
LoadSprite(Sprite3,$A4, $50,10)
ShowSprite(Sprite3, NO_WVRT)

'Display left arm
Dim Sprite4 As Byte=4
LoadSprite(Sprite4,$C7, $55,6)
ShowSprite(Sprite4, NO_WVRT)

'Display right leg
Dim Sprite5 As Byte=5
LoadSprite(Sprite5,$AC, $69,13)
ShowSprite(Sprite5, NO_WVRT)

'Display left leg
Dim Sprite6 As Byte=6
LoadSprite(Sprite6,$BA, $68,9)
ShowSprite(Sprite6, NO_WVRT)

'Display right hand
Dim Sprite7 As Byte=7
LoadSprite(Sprite7,$A2, $73,12)
ShowSprite(Sprite7, NO_WVRT)

'Display left hand
Dim Sprite8 As Byte=8
LoadSprite(Sprite8,$CA, $72,8)
ShowSprite(Sprite8, NO_WVRT)

'Display right foot
Dim Sprite9 As Byte=9
LoadSprite(Sprite9,$AC, $88,11)
ShowSprite(Sprite9, NO_WVRT)

'Display left foot
Dim Sprite10 As Byte=10
LoadSprite(Sprite10,$BA, $87,7)
ShowSprite(Sprite10, WVRT)
End Sub

Sub MontreSprite
  ShowSprite(Sprite1, NO_WVRT)
  ShowSprite(Sprite2, NO_WVRT)
  ShowSprite(Sprite3, NO_WVRT)
  ShowSprite(Sprite4, NO_WVRT)
  ShowSprite(Sprite5, NO_WVRT)
  ShowSprite(Sprite6, NO_WVRT)
  ShowSprite(Sprite7, NO_WVRT)
  ShowSprite(Sprite8, NO_WVRT)
  ShowSprite(Sprite9, NO_WVRT)
  ShowSprite(Sprite10, WVRT)
End Sub

Sub EffaceSprite
  DeleteSprite(Sprite10)
  DeleteSprite(Sprite9)
  DeleteSprite(Sprite8)
  DeleteSprite(Sprite7)
  DeleteSprite(Sprite6)
  DeleteSprite(Sprite5)
  DeleteSprite(Sprite4)
  DeleteSprite(Sprite3)
  DeleteSprite(Sprite2)
  DeleteSprite(Sprite1)
End Sub

Sub CheckForLetterInWord
  CHIP16BEGIN
  > WVRT
  CHIP16END
  Dim StartPos As Byte=1
  Dim StrPos As Byte
  Dim StrPos2 As Byte
  Dim StrPos3 As Byte
  StrPos = INSTR(LettersUsed,CharStr)
  If StrPos=0 Then
    LettersUsed=LettersUsed & CharStr
    StrPos=255
    Do Until StrPos=0
      StrPos = INSTR(StartPos,NewWordStr,CharStr)
      If StrPos<>0 Then
        StrPos2 = StrPos - 1
        StrPos3 = StrPos + 1
        NewWordMaskStr = LEFT(NewWordMaskStr,StrPos2) & MID(NewWordStr,StrPos,1) & MID(NewWordMaskStr,StrPos3)
        StartPos=StrPos+1
      Else
        If StartPos=1 Then
          'No letter found so move body part and check if hung
          'Uh-Oh
          PlayVOC(0)
          Delay(100)
          'Load "Now we put" in #4
          HangPtr=HangPtr+1
          Dim NoosePos As Byte=0
          If HangPtr=1 Then
            'Move head to noose area
            Gosub EffaceSprite
            LoadSprite(Sprite2,$A3, $2E, 5)
            Gosub MontreSprite
            GPrint At 3,210,"Now we put a head..."
            PlayVOC(1)
            Gosub WaitForSound
            PlayVOC(2)
            Gosub WaitForSound
            Do While NoosePos=0
              Gosub EffaceSprite
              MoveSpriteLeft(Sprite2,1,80)
              If SpriteX(Sprite2)=80 Then
                NoosePos=80
              End If
              Gosub MontreSprite
            Loop
          End If
          If HangPtr=2 Then
            'Move body to noose area
            GPrint At 3,210,"Now we put the upper body..."
            PlayVOC(1)
            Gosub WaitForSound
            PlayVOC(3)
            Gosub WaitForSound
            Do While NoosePos=0
              Gosub EffaceSprite
              MoveSpriteLeft(Sprite1,1,93)
              MoveSpriteDown(Sprite1,1,$50)
              If SpriteX(Sprite1)=93 Then
                NoosePos=93
              End If
              Gosub MontreSprite
            Loop
          End If
          If HangPtr=3 Then
            'Move right arm to noose area
            GPrint At 3,210,"Now we put the right arm..."
            PlayVOC(1)
            Gosub WaitForSound
            PlayVOC(4)
            Gosub WaitForSound
            Do While NoosePos=0
              Gosub EffaceSprite
              MoveSpriteLeft(Sprite3,1,82)
              MoveSpriteDown(Sprite3,1,$54)
              If SpriteX(Sprite3)=82 Then
                NoosePos=82
              End If
              Gosub MontreSprite
            Loop
          End If
          If HangPtr=4 Then
            'Move left arm to noose area
            GPrint At 3,210,"Now we put the left arm..."
            PlayVOC(1)
            Gosub WaitForSound
            PlayVOC(5)
            Gosub WaitForSound
            Do While NoosePos=0
              Gosub EffaceSprite
              MoveSpriteLeft(Sprite4,1,117)
              MoveSpriteDown(Sprite4,1,$57)
              If SpriteX(Sprite4)=117 Then
                NoosePos=117
              End If
              Gosub MontreSprite
            Loop
          End If
          If HangPtr=5 Then
            'Move right leg to noose area
            GPrint At 3,210,"Now we put the right leg..."
            PlayVOC(1)
            Gosub WaitForSound
            PlayVOC(6)
            Gosub WaitForSound
            Do While NoosePos=0
              Gosub EffaceSprite
              MoveSpriteLeft(Sprite5,1,91)
              MoveSpriteDown(Sprite5,1,$6D)
              If SpriteX(Sprite5)=91 Then
                NoosePos=91
              End If
              Gosub MontreSprite
            Loop
          End If
          If HangPtr=6 Then
            'Move left leg to noose area
            GPrint At 3,210,"Now we put the left leg..."
            PlayVOC(1)
            Gosub WaitForSound
            PlayVOC(7)
            Gosub WaitForSound
            Do While NoosePos=0
              Gosub EffaceSprite
              MoveSpriteLeft(Sprite6,1,105)
              MoveSpriteDown(Sprite6,1,$6C)
              If SpriteX(Sprite6)=105 Then
                NoosePos=105
              End If
              Gosub MontreSprite
            Loop
          End If
          If HangPtr=7 Then
            'Move right hand to noose area
            GPrint At 3,210,"Now we put the right hand..."
            PlayVOC(1)
            Gosub WaitForSound
            PlayVOC(8)
            Gosub WaitForSound
            Do While NoosePos=0
              Gosub EffaceSprite
              MoveSpriteLeft(Sprite7,1,80)
              MoveSpriteDown(Sprite7,1,$77)
              If SpriteX(Sprite7)=80 Then
                NoosePos=80
              End If
              Gosub MontreSprite
            Loop
          End If
          If HangPtr=8 Then
            'Move left hand to noose area
            GPrint At 3,210,"Now we put the left hand..."
            PlayVOC(1)
            Gosub WaitForSound
            PlayVOC(9)
            Gosub WaitForSound
            Do While NoosePos=0
              Gosub EffaceSprite
              MoveSpriteLeft(Sprite8,1,120)
              MoveSpriteDown(Sprite8,1,$76)
              If SpriteX(Sprite8)=120 Then
                NoosePos=120
              End If
              Gosub MontreSprite
            Loop
          End If
          If HangPtr=9 Then
            'Move right foot to noose area
            GPrint At 3,210,"Now we put the right foot..."
            PlayVOC(1)
            Gosub WaitForSound
            PlayVOC(10)
            Gosub WaitForSound
            Do While NoosePos=0
              Gosub EffaceSprite
              MoveSpriteLeft(Sprite9,1,92)
              MoveSpriteDown(Sprite9,1,$8C)
              If SpriteX(Sprite9)=92 Then
                NoosePos=92
              End If
              Gosub MontreSprite
            Loop
          End If
          If HangPtr=10 Then
            'Move left foot to noose area
            GPrint At 3,210,"Now we put the left foot..."
            PlayVOC(1)
            Gosub WaitForSound
            PlayVOC(11)
            Gosub WaitForSound
            Do While NoosePos=0
              Gosub EffaceSprite
              MoveSpriteLeft(Sprite10,1,105)
              MoveSpriteDown(Sprite10,1,$8B)
              If SpriteX(Sprite10)=105 Then
                NoosePos=105
              End If
              Gosub MontreSprite
            Loop
            PlayVOC(12)
            Gosub WaitForSound
            PlayVOC(13)
            Gosub WaitForSound
            UsedWordsCount=UsedWordsCount+1
            If UsedWordsCount<50 Then
              Goto AskToPlayAgain
            Else
              Goto CompletedAllWords
            End If
          End If
        End If
      End If
    Loop
  Else
    Color(1)
    GPrint At 5,210,"Already used '";CharStr;"'
  End If
  Color(36)
  GPrint At WordPos,231, STRDUP(LenOfNewWordStr, "_");
  Color(1)
  GPrint At WordPos,230, NewWordMaskStr;
End Sub

Sub GetNewWord
  If UsedWordsCount<50 Then
    Dim RandomWordOffset As Byte
    Dim UsedWordsTablePtr As Word=@UsedWordsTable
    Dim UsedWordsTableEnd As Word
    UsedWordsTableEnd=UsedWordsTablePtr + 50
    RandomWordOffset=Random(49)
    UsedWordsTablePtr=UsedWordsTablePtr + RandomWordOffset
    Dim PeekValue As Byte
    GetNewWordBR01:
    PeekValue=Peek(2),UsedWordsTablePtr
    If PeekValue=1 Then
      'If number is already taken, then find next available one.
      UsedWordsTablePtr = UsedWordsTablePtr + 1
      RandomWordOffset = RandomWordOffset + 1
      If UsedWordsTablePtr = UsedWordsTableEnd Then
        UsedWordsTablePtr = @UsedWordsTable
        RandomWordOffset = 0
      End If
      Goto GetNewWordBR01
    Else
      UsedWordsCount=UsedWordsCount + 1
      Poke(2),UsedWordsTablePtr, 1
      Dim position As Byte
      Dim HiddenWordsMemPtr As Word=@HiddenWords
      For position=0 To RandomWordOffset
        'Search for comma
        Dim CharByte As Byte=0
        Do Until CharByte=44
          CharByte=Peek(3),HiddenWordsMemPtr
          HiddenWordsMemPtr = HiddenWordsMemPtr + 1
        Loop
      Next
      'Get the word
      Dim CharByteStr As String(1)
      Dim NewWordStr As String(20)=""
      CharByte=Peek(3),HiddenWordsMemPtr
      Do Until CharByte=44
        CharByteStr=CHR(CharByte)
        NewWordStr = NewWordStr & CharByteStr
        HiddenWordsMemPtr = HiddenWordsMemPtr + 1
        CharByte=Peek(3),HiddenWordsMemPtr
      Loop
    End If
    Dim LenOfNewWordStr As Byte
    LenOfNewWordStr = LEN(NewWordStr)
    Dim NewWordMaskStr As String(20)
    NewWordMaskStr = STRDUP(LenOfNewWordStr, " ")
    Dim WordPos As Byte
    If LenOfNewWordStr<5 Then
      WordPos=120
    Else
      If LenOfNewWordStr<10 Then
        WordPos=100
      Else
        If LenOfNewWordStr<15 Then
          WordPos=60
        Else
          WordPos=30
        End If
      End If
    End If
    Color(36)
    GPrint At WordPos,231, STRDUP(LenOfNewWordStr, "_");
'    Color(2)
'    GPrint At 5,130, NewWordStr
  Else
    GPrint At 5,70,"You've completed"
    GPrint At 5,79,"all 50 words!"
  End If
  Delay(50)
End Sub

Sub WaitForSound
WaitForSoundBR:
  If VOCEnd<>0 Then
    Goto WaitForSoundBR
  End If
End Sub

CHIP16BEGIN
@HiddenWords
$ ,GUM,SIN,FOR,CRY,LUG,BYE,FLY,
$ UGLY,EACH,FROM,WORK,TALK,WITH,SELF,
$ PIZZA,THING,FEIGN,FIEND,ELBOW,FAULT,DIRTY,
$ BUDGET,SPIRIT,QUAINT,MAIDEN,ESCORT,PICKAX,
$ EXAMPLE,TENSION,QUININE,KIDNEYS,REPLICA,SLEEPER,
$ TRIANGLE,KANGAROO,MAHOGANY,SERGEANT,SEQUENCE,
$ MOUSTACHE,DANGEROUS,SCIENTIST,DIFFERENT,QUIESCENT,
$ MAGISTRATE,ERRONEOUSLY,LOUDSPEAKER,PHYTOTOXIC,
$ MATRIMONIAL,PARASYMPATHOMIMETIC,THIGMOTROPISM,
@UsedWordsTable
* 00 00 00 00 00 00 00 00 00 00
* 00 00 00 00 00 00 00 00 00 00
* 00 00 00 00 00 00 00 00 00 00
* 00 00 00 00 00 00 00 00 00 00
* 00 00 00 00 00 00 00 00 00 00
CHIP16END